const path = require('path')
const zlib = require('zlib')
const tarStreamExtract = require('tar-stream').extract

const cb = err => {
  if (err) throw err
}

module.exports = function tarStreamToArray(tarStream) {
  return new Promise(resolve => {
    const extract = tarStreamExtract()

    const files = []

    extract.on('error', cb)

    extract.on('entry', (header, stream, next) => {
      let content = ''

      stream.on('data', chunk => {
        content += chunk
      })

      stream.on('end', () => {
        const dirname = path.dirname(header.name)
        const filename = path.basename(header.name)
        const extname = path.extname(header.name)

        if (header.type === 'file') {
          files.push({
            dirname,
            filename,
            extname,
            content,
          })
        }

        next()
      })

      stream.resume()
    })

    extract.on('finish', () => {
      resolve(files)
    })

    tarStream.pipe(zlib.createGunzip()).pipe(extract)
  })
}
