const fs = require('fs')
const http = require('http')
const tarStreamToArray = require('./')

const tempRepoTarPath = '/tmp/repo.tar.gz'
const gzippedStream = fs.createReadStream(tempRepoTarPath)

beforeAll(() => {
  const file = fs.createWriteStream(tempRepoTarPath)
  http.get(
    'http://codeload.github.com/tankywoo/dotfiles/legacy.tar.gz/master',
    response => {
      response.pipe(file)
    },
  )
})

afterAll(() => fs.unlink(tempRepoTarPath))

it('should return a promise that resolves with an array as the first argument', () => {
  tarStreamToArray(gzippedStream).then(result => {
    expect(Array.isArray(result)).toBe(true)
  })
})
